
iNumFavs = 7;
iMaxSize = 35;
iRelSize = (myPicker:GetWidth() / iNumFavs);-- - (10 * (iNumFavs-1));

blFavReplace = {}; -- If this is true user is wanting to replace a favourite color, so color picker and hex editor need to pass to that instead.

if iRelSize > iMaxSize then iRelSize = iMaxSize end

-- Initial 'replace = false' values

for tI=1, iNumFavs, 1 do
	blFavReplace[tI] = false;
end


lblFavorites = Turbine.UI.Label();
lblFavorites:SetParent(wParentWin);
lblFavorites:SetSize(130,18);
lblFavorites:SetPosition(myPicker:GetLeft(),myPicker:GetTop() + myPicker:GetHeight() + 10);
lblFavorites:SetForeColor(Turbine.UI.Color(0,0.8,0.8));
lblFavorites:SetFont(Turbine.UI.Lotro.Font.Verdana16);
lblFavorites:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
lblFavorites:SetText("Favorite Colors");
lblFavorites:SetVisible(true);

iTop = lblFavorites:GetTop() + lblFavorites:GetHeight() + 8;

wFavBack = {};
wFavColor = {};

for i=1, iNumFavs, 1 do

	curLeft = myPicker:GetLeft() + (i-1)*((myPicker:GetWidth()-iRelSize)/(iNumFavs-1));
	wFavBack[i] = Turbine.UI.Window();
	wFavBack[i]:SetParent(wParentWin);
	wFavBack[i]:SetSize(iRelSize,iRelSize);
	wFavBack[i]:SetPosition(curLeft,iTop);
	wFavBack[i]:SetBackColor(Turbine.UI.Color(1,1,1));
	wFavBack[i]:SetVisible(true);

	wFavColor[i] = Turbine.UI.Window();
	wFavColor[i]:SetParent(wFavBack[i]);
	wFavColor[i]:SetSize(iRelSize-2,iRelSize-2);
	wFavColor[i]:SetPosition(1,1);
	wFavColor[i]:SetBackColor(Turbine.UI.Color(0.1,0.1,0.1));
	wFavColor[i]:SetVisible(true);

	wFavColor[i].MouseClick = function(sender, args)

		if (args.Button == Turbine.UI.MouseButton.Right) then

			displayFavMenu(sender,i);

		else

			colorString = sender:GetBackColor();
			SetColor(colorString.R,colorString.G,colorString.B);

		end

	end

end




function createFavMenu(BlockSender,index)

	-- Data storeage

	local MenuBackcolor = Turbine.UI.Color(0.0, 0.0, 0.0);

	local initX = Turbine.UI.Display.GetMouseX();
	local initY = Turbine.UI.Display.GetMouseY();
	local screenHeight = Turbine.UI.Display.GetHeight();
	local screenWidth = Turbine.UI.Display.GetWidth();

	--local menuMaxHeight = (screenHeight / 2);
	local menuMaxHeight = 200;
	local menuCurHeight = 0;
	local menuCurTop = 3;

	local i = 1;
	local mCounter = 1;
	local lineHeight = 25; -- Height of each line in the menu.
	local linebuffer = 3;
	local menuWidth = 145;

	-------------------------------------------------------------------------
	-- Windows

	winFavMenuParent = Turbine.UI.Window();
	winFavMenuParent:SetBackColor(MenuBackcolor);
	winFavMenuParent:SetMouseVisible(true);
	winFavMenuParent:SetOpacity(0);
	winFavMenuParent:SetPosition(0,0);
	winFavMenuParent:SetSize(screenWidth,screenHeight);
	winFavMenuParent:SetVisible(false);
	winFavMenuParent:SetZOrder(198);

	winFavMenuBody = Turbine.UI.Window();
	winFavMenuBody:SetParent(winFavMenuParent);
	winFavMenuBody:SetBackColor(MenuBackcolor);
	winFavMenuBody:SetMouseVisible(true);
	winFavMenuBody:SetOpacity(0.8);
	winFavMenuBody:SetVisible(true);
	winFavMenuBody:SetWidth(menuWidth);
	winFavMenuBody:SetZOrder(199);

	winFavMenuHolder = Turbine.UI.Control();
	winFavMenuHolder:SetParent(winFavMenuBody);
	winFavMenuHolder:SetBackColor(MenuBackcolor);
	winFavMenuHolder:SetMouseVisible(true);
	winFavMenuHolder:SetOpacity(0);
	winFavMenuHolder:SetVisible(true);
	winFavMenuHolder:SetWidth(menuWidth);
	winFavMenuHolder:SetZOrder(200);

	fscrollBar = Turbine.UI.ScrollBar();
	fscrollBar:SetParent(winFavMenuBody);
	fscrollBar:SetTop(0);
	fscrollBar:SetZOrder(201);
	fscrollBar:SetMinimum(0);
	fscrollBar:SetWidth(15);
	fscrollBar:SetValue(0);
	fscrollBar:SetOrientation(Turbine.UI.Orientation.Vertical);

	favScrollIncBut = Turbine.UI.Button();
	favScrollIncBut:SetSize(15,15);
	favScrollIncBut:SetBackground("GaluhadPlugins/ChatEdit/resources/scrollbar_inc_up.tga");
	--favScrollIncBut:SetParent(fscrollBar);

	FavScrollDecBut = Turbine.UI.Button();
	FavScrollDecBut:SetSize(15,15);
	FavScrollDecBut:SetBackground("GaluhadPlugins/ChatEdit/resources/scrollbar_dec_up.tga");
	--FavScrollDecBut:SetParent(fscrollBar);

	scrollThumb = Turbine.UI.Control();
	scrollThumb:SetSize(15,15);
	scrollThumb:SetBackground("GaluhadPlugins/ChatEdit/resources/scrollbar_thumb.tga");
	--scrollThumb:SetParent(fscrollBar);

	fscrollBar:SetDecrementButton(FavScrollDecBut);
	fscrollBar:SetIncrementButton(favScrollIncBut);
	fscrollBar:SetThumbButton(scrollThumb);

	local curFavColor = BlockSender:GetBackColor();
	curColorString = "R=" .. math.floor(255*curFavColor.R) .. ", G=" .. math.floor(255*curFavColor.G) .. ", B=" .. math.floor(255*curFavColor.B);


	if blFavReplace[index] == true then -- Replace already active so swap to 'cancel'

		tFavMenu =
		{
			[1] =
			{
				["Name"] = curColorString;
			};
			[2] =
			{
				["Name"] = "Cancel";
			};

		};

	else

		tFavMenu =
		{
			[1] =
			{
				["Name"] = curColorString;
			};
			[2] =
			{
				["Name"] = "Replace";
			};

		};

	end

	local numOfSlots = 2;


	winFavMenuItem = {};
	winFavMenuLabel = {};

	--------------------------------------------------------------------------
	-- This loop determines which gambits to add to the menu, and creates
	-- the menu on the fly.

	while i <= numOfSlots do -- loops through all the gambits in the table.

		local gName = tFavMenu[i].Name;

		winFavMenuItem[mCounter] = Turbine.UI.Control();
		winFavMenuItem[mCounter]:SetHeight(lineHeight);
		winFavMenuItem[mCounter]:SetLeft(linebuffer);
		winFavMenuItem[mCounter]:SetTop(menuCurTop);
		winFavMenuItem[mCounter]:SetWidth(menuWidth - (2 * linebuffer));
		winFavMenuItem[mCounter]:SetBackColor(Turbine.UI.Color(0.0, 0.0, 0.0));
		winFavMenuItem[mCounter]:SetOpacity(1);
		winFavMenuItem[mCounter]:SetMouseVisible(true);
		winFavMenuItem[mCounter]:SetParent(winFavMenuHolder);


		winFavMenuLabel[mCounter] = Turbine.UI.Label();
		winFavMenuLabel[mCounter]:SetParent(winFavMenuItem[mCounter]);
		winFavMenuLabel[mCounter]:SetHeight(lineHeight-4);
		winFavMenuLabel[mCounter]:SetLeft(0);
		winFavMenuLabel[mCounter]:SetTop(2);
		winFavMenuLabel[mCounter]:SetWidth(winFavMenuItem[mCounter]:GetWidth());
		winFavMenuLabel[mCounter]:SetText(gName);
		winFavMenuLabel[mCounter]:SetForeColor(Turbine.UI.Color(1,1,1));
		winFavMenuLabel[mCounter]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
		winFavMenuLabel[mCounter]:SetMultiline(false);
		winFavMenuLabel[mCounter]:SetMouseVisible(false);


		------------------------------------------------------------------------------
		-- Mouse event handlers
		winFavMenuItem[mCounter].MouseEnter = function(sender, args)

			local Children = sender:GetControls();
			local cCount = Children:GetCount();
			local label = Children:Get(cCount);
			local selItem = label:GetText();

			if selItem ~= curColorString then

				sender:SetBackColor(Turbine.UI.Color(0.0, 0.3, 0.3));

			end

		end


		winFavMenuItem[mCounter].MouseLeave = function(sender, args)
			sender:SetBackColor(Turbine.UI.Color(0.0, 0.0, 0.0));
		end


		winFavMenuItem[mCounter].MouseClick = function(sender, args)

			-- This block of code will determine which winFavMenuItem was
			-- clicked and return it's child controls so we can see
			-- which label child corresponds to it.
			local Children = sender:GetControls();
			local cCount = Children:GetCount();
			local label = Children:Get(cCount);
			local selItem = label:GetText();

			--loop through tables to find selected item
			local y = 1;

			while y <= numOfSlots do
				local selName = tFavMenu[y].Name;
				if selName == selItem then


					-- DO SOMETHING HERE

					if selItem == "Replace" then

						enableFavReplace(BlockSender,index);

					elseif selItem == "Cancel" then

						disableFavReplace(index);

					end



					break
				else
					y = y + 1;
				end

			end

			winFavMenuParent:SetVisible(false); -- Hide menu after click.

		end


		-- Click outside menu, close window.
		winFavMenuParent.MouseClick = function(sender, args)
			winFavMenuParent:SetVisible(false);
		end


		------------------------------------------------------------------------------
		-- Increments

		menuCurTop = menuCurTop + lineHeight + linebuffer;

		mCounter = mCounter + 1;
		menuCurHeight = menuCurTop;


		if menuCurHeight > menuMaxHeight then
			-- Do not make menu larger, instead add a scrollbar.
			winFavMenuBody:SetHeight(menuMaxHeight);
			winFavMenuBody:SetWidth(menuWidth + 16);
			winFavMenuHolder:SetHeight(menuCurHeight);

			fscrollBar:SetLeft(menuWidth);
			fscrollBar:SetMaximum(menuCurHeight - menuMaxHeight);
			fscrollBar:SetHeight(menuMaxHeight);

			favScrollIncBut:SetTop(fscrollBar:GetHeight()-15);
			FavScrollDecBut:SetTop(0);
			scrollThumb:SetTop(15);
			fscrollBar:SetVisible(true);

			local visiblePercent = menuMaxHeight / menuCurHeight;
			local thumbSize = (menuMaxHeight * visiblePercent) - 30;

			scrollThumb:SetHeight(thumbSize);
			scrollThumb:SetStretchMode(3);

			fscrollBar:SetSmallChange(10);
			fscrollBar:SetLargeChange(20);

			fscrollBar.ValueChanged = function(sender, args)
				-- Move the Holder Window up/down depending on bar value.
				local thumbValue = fscrollBar:GetValue();
				local holderTop = -(thumbValue);

				winFavMenuHolder:SetTop(holderTop);
			end

		else
			winFavMenuBody:SetHeight(menuCurHeight);
			winFavMenuBody:SetWidth(menuWidth);
			winFavMenuHolder:SetHeight(menuCurHeight);
			fscrollBar:SetVisible(false);
		end

		-- increment i for loop.
		i = i + 1;

	end

end


-- This function will display the menu at the current mouse position,
-- repositioning it so it doesn't appear off-screen.
function displayFavMenu(sender,index)

	createFavMenu(sender,index);

	local initX = Turbine.UI.Display.GetMouseX();
	local initY = Turbine.UI.Display.GetMouseY();
	local screenHeight = Turbine.UI.Display.GetHeight();
	local screenWidth = Turbine.UI.Display.GetWidth();
	local menuHeight = winFavMenuBody:GetHeight();
	local menuWidth = winFavMenuBody:GetWidth();

	if (initX + menuWidth) > screenWidth then
		-- Menu will appear off-screen to the left, so load it to the right
		-- of the mouse location.#
		winFavMenuBody:SetLeft(initX - menuWidth);
	else
		winFavMenuBody:SetLeft(initX);
	end

	if (initY + menuHeight) > (screenHeight - 75) then
		-- Menu will appear off-screen to the bottom, so load it to touch
		-- the bottom of the screen.
		winFavMenuBody:SetTop(screenHeight - menuHeight - 75);
	else
		winFavMenuBody:SetTop(initY);
	end

	fscrollBar:SetValue(0);
	winFavMenuHolder:SetTop(0);

	winFavMenuParent:SetVisible(true);

end
